﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DFU_Example
{
    public partial class MainForm : Form
    {
        IFirmwareUpdate firmwareUpdate = new FirmwareUpdate();

        public MainForm()
        {
            InitializeComponent();
        }

        private void btnProgram_Click(object sender, EventArgs e)
        {
            UInt16 VID;
            UInt16 PID;
            UInt16 Version;

            try
            {
                firmwareUpdate.OnFirmwareUpdateProgress += FirmwareUpdateProgressHandler;
                if (DialogResult.OK == dlgOpenFile.ShowDialog())
                {
                    firmwareUpdate.ParseDFU_File(dlgOpenFile.FileName, out VID, out PID, out Version);

                    // Check that the file's VID, PID and Version are OK, then update
                    firmwareUpdate.UpdateFirmware(dlgOpenFile.FileName, false);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnMassErase_Click(object sender, EventArgs e)
        {
            firmwareUpdate.MassErase();
        }

        private void FirmwareUpdateProgressHandler(object sender, FirmwareUpdateProgressEventArgs e)
        {
            if (Progress.InvokeRequired)
            {
                Invoke(new EventHandler<FirmwareUpdateProgressEventArgs>(FirmwareUpdateProgressHandler), new object[] { sender, e });
            }
            else
            {
                lblMessage.Text = e.Message;
                Progress.Value = (int)e.Percentage;
                if (e.Failed)
                {
                    MessageBox.Show(e.Message, "Firmware update failed");
                }
            }
        }
    }
}
